//JSEvent
// var dom = document;

String.prototype.replaceAll = function(s1,s2){
    return this.replace(new RegExp(s1,"gm"),s2);
}
var JSEvent = function(el) {
    return new _JSEvent(el);    
};
var _JSEvent = function(el) {
    this.el = (el && el.nodeType == 1)? el: document;
};
_JSEvent.prototype = {
    constructor: _JSEvent,
    addEvent: function(type, fn, capture) {
        var el = this.el;
        
        if (window.addEventListener) {
            el.addEventListener(type, fn, capture);

            var ev = document.createEvent("HTMLEvents");
            ev.initEvent(type, capture || false, false);
            // 在元素上存储创建的事件，方便自定义触发
            if (!el["ev" + type]) {
                el["ev" + type] = ev;
            }
            
        } else if (window.attachEvent) {
            el.attachEvent("on" + type, fn);    
            if (isNaN(el["cu" + type])) {
                // 自定义属性，触发事件用
                el["cu" + type] = 0; 
            }
            
            var fnEv = function(event) {
                if (event.propertyName == "cu" + type) {
                    fn.call(el);
                }
            };
            
            el.attachEvent("onpropertychange", fnEv);
            
            // 在元素上存储绑定的propertychange事件，方便删除
            if (!el["ev" + type]) {
                el["ev" + type] = [fnEv];
            } else {
                el["ev" + type].push(fnEv);    
            }
        }
        
        return this;
    },
    fireEvent: function(type) {
        var el = this.el;
        if (typeof type === "string") {
            if (document.dispatchEvent) {
                if (el["ev" + type]) {
                    el.dispatchEvent(el["ev" + type]);
                }
            } else if (document.attachEvent) {
                // 改变对应自定义属性，触发自定义事件
                el["cu" + type]++;
            }    
        }    
        return this;
    },
    removeEvent: function(type, fn, capture) {
        var el = this.el;
        if (window.removeEventListener) {
            el.removeEventListener(type, fn, capture || false);
        } else if (document.attachEvent) {
            el.detachEvent("on" + type, fn);
            var arrEv = el["ev" + type];
            if (arrEv instanceof Array) {
                for (var i=0; i<arrEv.length; i+=1) {
                    // 删除该方法名下所有绑定的propertychange事件
                    el.detachEvent("onpropertychange", arrEv[i]);
                }
            }
        }
        return this;    
    }
};
//loadURL 
function loadURL(url) {
    var iFrame;
    iFrame = document.createElement("iframe");
    iFrame.setAttribute("src", url);
    iFrame.setAttribute("style", "display:none;");
    iFrame.setAttribute("frameborder", "0");
    document.body.appendChild(iFrame);
    // 发起请求后这个 iFrame 就没用了，所以把它从 dom 上移除掉
    iFrame.parentNode.removeChild(iFrame);
    iFrame = null;
}
//iOS Mapping
var iOSMapping= {
'model':'k3LE',
'networkType':'Swlw',
'packageName':'VQFA',
'totalMemory':'oUvy',
'totalSystem':'bxIT',
'cellularIP':'PneH',
'resolution':'9_vV',
'IDFA':'bA0Q',
'brightness':'qm7W',
'IDFV':'sxWp',
'startupTime':'oA3w',
'wifiList':'wXg4',
'version':'XKTz',
'appVersion':'wfQn',
'battery':'89Fw',
'rooted':'UqMW',
'activeTime':'R7of',
'carrier':'WANY',
'language':'pO8w',
'sdkVersion':'Vkrm',
'fork':'jQx6',
'appCache':'9PRr',
'contactsHash':'kClR',
'isVPN':'G0rn',
'isProxy':'m6C7',
'coordinates':'Kavb',
'appList':'nt7F',
'account':'mvIR',
'userAgent':'0aew',
'availableSystem':'H6Rg',
'wapSmartID':'fWZT',
'expireTime':'dBET',
};
//embed.js
var SDKElement = "";
var dom = document;
var dfp  = "";
var webviewType = '';
/**
 * 统一replace 方法
 **/
function replaceEle(element){
    if(element==null||element==""||element==undefined){
        return null;
    }
    return element.replace(/\&|\+|\?|\%|\#|\/|\=/g, "");
}
/**
	注入SDK采集要素接口
	param1: 采集要素json结合
	param2: 平台信息 iOS/AND
**/
function inputFields(jsonObj,platform,jsUrl){
    alert(JSON.stringify(jsonObj)+jsUrl);

    window.webviewType = platform;
	if(platform ==="IOS"){
        window.SDKElement = jsonObj;
        window.SDKElement["platform"] = "IOS"
	}else{
		window.SDKElement = null;
    }
    
    if(window.SDKElement!=null && platform=="IOS"){
        var replaceResult = replaceEle(window.SDKElement["account"]);
        if(replaceResult!=null) window.SDKElement["account"] = replaceResult;
        
        replaceResult = replaceEle(window.SDKElement["userAgent"]); 
        if(replaceResult!=null) window.SDKElement["userAgent"] = replaceResult;
        
        replaceResult = replaceEle(window.SDKElement["wifiList"]);
        if(replaceResult!=null) window.SDKElement["wifiList"] = replaceResult;
    }

	if(SDKElement!=null&&SDKElement!=""&&SDKElement!=undefined){
		var script = document.createElement("script");
		script.src = jsUrl;
		document.head.appendChild(script);
	}
}
function getFingerPrint(){	
new JSEvent(dom).addEvent("RailEvent", function() {
   if(window.webviewType==="IOS"){
      if(Boolean(navigator.userAgent.match(/OS [1-8]_\d[_\d]* like Mac OS X/i))){
        loadURL("dfp://"+window.dfp);        
      }else {
        window.location.href= "dfp://"+window.dfp;
      }
   }
});
}
getFingerPrint();
